int Width = 720;
int Height = 480;

color GrassGreen = color(101, 207, 41);
color GrassColor = GrassGreen;
color BrickBrown = color(234, 171, 140);
color WallColor = BrickBrown;
color WheatYellow = color(255, 220, 92);
color RoofColor = WheatYellow;
color OceanBlue = color(32, 88, 147);
color OceanRed = color(100, 27, 21);
color OceanNight = color(22, 37, 76);
color OceanColor = OceanBlue;
color SkyBlue = color(148, 197, 248);
color SkyOrange = color(135, 47, 2);
color SkyNight = color(33, 51, 129);
color SkyColor = SkyBlue;
color SunYellow = color(251, 254, 151);
color SunSet = color(222, 69, 0);
color SunColor = SunYellow;
color CloudWhite = color(249, 253, 254);
color CloudColor = CloudWhite;
color MoonBright = color(247, 231, 169);
color MoonDark = color(176, 160, 145);
color MoonColor = MoonBright;
color WoodBrown = color(204, 138, 94);
color TreeColor = WoodBrown;
color LeafGreen = color(148, 206, 81);
color LeafColor = LeafGreen;
color BoatWhite = color(237, 245, 247);
color BoatColor = BoatWhite;
color StarWhite = color(255, 200);
color StarColor = StarWhite;

float HorizonY = 400;

float SunRadius = 25;
float SunX = 150;
float SunStartY = 100;
float SunMiddleY = 350;
float SunEndY = 700; 
float SunY = SunStartY;
float SunRatio = 0;

float MoonRadius = 30;
float MoonY = 150;
float MoonStartX = Width + MoonRadius;
float MoonEndX = -MoonRadius;
float MoonX = MoonStartX;
float MoonMiddleX = (MoonEndX + MoonStartX) / 2;
float MoonRatio = 0;

float Moon_dY = 5;
float Sun_dY = (Moon_dY / (MoonStartX - MoonEndX)) * ((SunEndY - SunMiddleY) * 2);

int DAY = 0;
int NIGHT = 1;
int TimeOfDay = DAY;

int CLEAR = 0;
int RAINING = 1;
int Weather = CLEAR;

int RainCounter = 0;
int MaxRainCounter = 1200; // rain will last for this number of frames

float CloudSpeed = 0.5;
float CloudX = 350;
float CloudY = 125;
float CloudRadius = 40;

float BoatCenterX = 100;
float BoatCenterY = 375;
float Boat_dX = 0.1;
float Boat_dY = 0;
float BoatR = 20;
float BoatTrailPos = 0;

float brightnessRange = 150;

int StartRainLineX = Width / 2;
int StartRainLineY = Height / 2;
int RainLineLength = 20;

int P1 = 263;
int P2 = 71;

void setup() {  
  size(Width, Height);
}

void draw() {  
  calculateRatios();
  setDayNight();
  changeSunColor();
  changeGrassColor();  
  changeHouseColor();
  changeSkyColor();
  changeOceanColor();
  changeCloudColor();
  changeTreeColor();
  changeLeafColor();
  changeBoatColor();
  changeMoonColor();
  changeStarColor();
  updateRainCounter();
  moveRain();
  moveCloud();
  moveBoat();
  background(SkyColor);  
  drawRainbow();
  drawSun();
  drawMoon();
  drawAllStars();
  drawCloud();
  drawWater();
  drawBoat();
  drawGrass();
  drawTree();
  drawHouse();
  drawRain();  
}

void keyTyped() {  
  if (key == ' ') {
    moveSun();
    moveMoon();
  } else if (key == 'r') {
    toggleRain();
  }
}

void toggleRain() {  
  if (Weather == CLEAR) {
    Weather = RAINING;
  }  
}

void updateRainCounter() {
  if (Weather == RAINING) {
    ++RainCounter;
  }
  if (RainCounter > MaxRainCounter) {
    RainCounter = 0;
    Weather = CLEAR;
  }
}

// x % y (for x > 0)
int mod(int x, int y) {
  return (x / y + 1) * y - x;
}

void moveRain() {
  StartRainLineX = mod(StartRainLineX * P1 + P2, width);
  StartRainLineY = mod(StartRainLineX * P1 + P2, height);  
}

void moveCloud() {
  CloudX -= CloudSpeed;
  if (CloudX < -CloudRadius * 4) {
    CloudX = width + CloudRadius;
  }
}

void moveBoat() {
  BoatCenterX += Boat_dX;
  BoatCenterY += Boat_dY;
  if (BoatCenterX > width) {
    BoatCenterX = -BoatR;
  }
  
  BoatTrailPos += 5;
  if (BoatTrailPos > 10) {
    BoatTrailPos = 0;
  }
}

void moveSun() {
  SunY += Sun_dY;
  if ((SunY < SunStartY) || (SunY > SunEndY)) {
    Sun_dY *= -1;
  }
}

void moveMoon() {
  if (TimeOfDay == NIGHT) {
    MoonX -= 5;
    if (MoonX < MoonEndX) {
      MoonX = MoonStartX;
    }
  }
}

void setDayNight() {
  if (SunY < SunMiddleY) {
    TimeOfDay = DAY;
  } else {
    TimeOfDay = NIGHT;  
  }
}

void calculateRatios() {
  calculateSunRatio();
  calculateMoonRatio();   
}

void calculateSunRatio() {
  SunRatio = (SunY - SunStartY) / (SunMiddleY - SunStartY);
  if (SunRatio > 1) {
    SunRatio = 1;
  }  
}

void calculateMoonRatio() {
  if (MoonX >= MoonMiddleX) {
    MoonRatio = (MoonStartX - MoonX) / (MoonStartX - MoonMiddleX);
  } else {
    MoonRatio = (MoonX - MoonEndX) / (MoonMiddleX - MoonEndX);
  }
}

void changeSunColor() {  
  float sunR = red(SunYellow) + SunRatio * (red(SunSet) - red(SunYellow));
  float sunG = green(SunYellow) + SunRatio * (green(SunSet) - green(SunYellow));
  float sunB = blue(SunYellow) + SunRatio * (blue(SunSet) - blue(SunYellow));
  SunColor = color(sunR, sunG, sunB);
}

void changeGrassColor() {
  GrassColor = varyBrightnessBaseOnSunPosition(GrassGreen);
}

void changeHouseColor() {
  WallColor = varyBrightnessBaseOnSunPosition(BrickBrown);
  RoofColor = varyBrightnessBaseOnSunPosition(WheatYellow);
}

void changeCloudColor() {
  CloudColor = varyBrightnessBaseOnSunPosition(CloudWhite);
}

void changeTreeColor() {
  TreeColor = varyBrightnessBaseOnSunPosition(WoodBrown);
}

void changeLeafColor() {
  LeafColor = varyBrightnessBaseOnSunPosition(LeafGreen);
}

void changeBoatColor() {
  BoatColor = varyBrightnessBaseOnSunPosition(BoatWhite);
}

void changeStarColor() {
  if (TimeOfDay == NIGHT) {
    StarColor = varyBrightnessBaseOnMoonPosition(StarWhite);
  }
}

color varyBrightnessBaseOnSunPosition(color baseColor) {
  colorMode(HSB);
  color newColor = color(hue(baseColor), saturation(baseColor), brightness(baseColor) - SunRatio * brightnessRange, alpha(baseColor));
  colorMode(RGB);
  return newColor;
}

color varyBrightnessBaseOnMoonPosition(color baseColor) {
  colorMode(HSB);
  color newColor = color(hue(baseColor), saturation(baseColor), brightness(baseColor) - (1 - MoonRatio) * brightnessRange, alpha(baseColor));
  colorMode(RGB);
  return newColor;
}

void changeSkyColor() {
  if (TimeOfDay == DAY) {
    SkyColor = interpolateColor(SkyBlue, SkyOrange, SunRatio);
  } else {
    SkyColor = interpolateColor(SkyOrange, SkyNight, MoonRatio);
  }  
}

void changeOceanColor() {
  if (TimeOfDay == DAY) {
    OceanColor = interpolateColor(OceanBlue, OceanRed, SunRatio);
  } else {
    OceanColor = interpolateColor(OceanRed, OceanNight, MoonRatio);
  }
}

void changeMoonColor() {
  if (TimeOfDay == NIGHT) {
    MoonColor = interpolateColor(MoonDark, MoonBright, MoonRatio);
  }
}

color interpolateColor(color startColor, color endColor, float ratio) {
  float dR = red(endColor) - red(startColor);
  float dG = green(endColor) - green(startColor);
  float dB = blue(endColor) - blue(startColor);
  float dA = alpha(endColor) - alpha(startColor);
  return color(dR * ratio + red(startColor),
               dG * ratio + green(startColor),
               dB * ratio + blue(startColor),
               dA * ratio + alpha(startColor));
}

void drawGrass() {
  noStroke();  
  fill(GrassColor);
  ellipse(1000, 800, 2500, 1000);  
}

void drawHouse() {
  noStroke();
  fill(RoofColor);
  ellipse(430, 350, 160, 160);
  fill(WallColor);
  rect(350, 350, 160, 80);  
}

void drawWater() {
  noStroke();  
  fill(OceanColor);
  rect(0, 325, width, height);
}

void drawSun() {
  noStroke();  
  fill(SunColor);
  ellipse(SunX, SunY, SunRadius * 2, SunRadius * 2);
}

void drawMoon() {
  noStroke();
  fill(MoonColor);
  ellipse(MoonX, MoonY, MoonRadius * 2, MoonRadius * 2);
  fill(SkyColor);
  ellipse(MoonX - 25, MoonY, MoonRadius * 2, MoonRadius * 2);
}

void drawCloud() {
  noStroke();
  fill(CloudColor);
  ellipse(CloudX, CloudY, CloudRadius * 2, CloudRadius * 2);
  ellipse(CloudX + 50, CloudY, CloudRadius * 2, CloudRadius * 2);
  ellipse(CloudX + 100, CloudY, CloudRadius * 2, CloudRadius * 2);
  ellipse(CloudX + 25, CloudY - 25, CloudRadius * 2, CloudRadius * 2);
  ellipse(CloudX + 75, CloudY - 25, CloudRadius * 2, CloudRadius * 2);
}

void drawRain() {
  if (Weather != RAINING) {
    return;
  }
  
  noFill();
  strokeWeight(1);
  stroke(240, 127);
  line(StartRainLineX, StartRainLineY, StartRainLineX - RainLineLength, StartRainLineY + RainLineLength);  
  line(StartRainLineX + 152                 , StartRainLineY - 211,
       StartRainLineX + 152 - RainLineLength, StartRainLineY - 211 + RainLineLength);  
  line(StartRainLineX - 267                 , StartRainLineY - 212,
       StartRainLineX - 267 - RainLineLength, StartRainLineY - 212 + RainLineLength);  
  line(StartRainLineX - 303                 , StartRainLineY + 209,
       StartRainLineX - 303 - RainLineLength, StartRainLineY + 209 + RainLineLength);  
  line(StartRainLineX + 18                 , StartRainLineY + 74,
       StartRainLineX + 18 - RainLineLength, StartRainLineY + 74 + RainLineLength);  
  line(StartRainLineX - 284                 , StartRainLineY - 229,
       StartRainLineX - 284 - RainLineLength, StartRainLineY - 229 + RainLineLength);  
  line(StartRainLineX - 39                 , StartRainLineY - 186,
       StartRainLineX - 39 - RainLineLength, StartRainLineY - 186 + RainLineLength);  
  line(StartRainLineX + 142                 , StartRainLineY - 13,
       StartRainLineX + 142 - RainLineLength, StartRainLineY - 13 + RainLineLength);  
  line(StartRainLineX - 321                 , StartRainLineY + 67,
       StartRainLineX - 321 - RainLineLength, StartRainLineY + 67 + RainLineLength);  
  line(StartRainLineX + 112                 , StartRainLineY + 101,
       StartRainLineX + 112 - RainLineLength, StartRainLineY + 101 + RainLineLength);  
}

void drawRainbow() {
  if ((Weather != RAINING) || (TimeOfDay != DAY)) {
    return;
  }
  
  float rainbowOpacity = 0;
  float halfMaxRainCounter = MaxRainCounter / 2.0;
  if (RainCounter < halfMaxRainCounter) {
    rainbowOpacity = 100 * (RainCounter / halfMaxRainCounter);
  } else {
    rainbowOpacity = 100 * ((MaxRainCounter - RainCounter) / halfMaxRainCounter);
  }
  
  float rainbowX = 720;
  float maxRadius = 950;
  float radiusStep = 18;
  
  noFill();
  strokeWeight(10);   
  stroke(255, 0, 0, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius, maxRadius);
  stroke(255, 118, 66, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - radiusStep, maxRadius - radiusStep);
  stroke(255, 255, 0, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - 2 * radiusStep, maxRadius - 2 * radiusStep);
  stroke(255, 255, 0, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - 3 * radiusStep, maxRadius - 3 * radiusStep);
  stroke(0, 255, 0, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - 4 * radiusStep, maxRadius - 4 * radiusStep);
  stroke(0, 171, 255, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - 5 * radiusStep, maxRadius - 5 * radiusStep);
  stroke(0, 0, 149, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - 6 * radiusStep, maxRadius - 6 * radiusStep);
  stroke(0, 66, 171, rainbowOpacity);
  ellipse(rainbowX, HorizonY, maxRadius - 7 * radiusStep, maxRadius - 7 * radiusStep);
}

void drawTree() {
  noFill();
  strokeWeight(40);
  strokeCap(PROJECT);
  stroke(TreeColor);
  line(600, 400, 570, 200);
  line(570, 400, 600, 200);
  strokeWeight(50);
  line(585, 390, 585, 200);
  strokeWeight(20);
  line(585, 210, 500, 200);
  strokeWeight(30);
  line(585, 220, 650, 120);
  
  noStroke();
  fill(LeafColor, 220);
  float leafDiameter = 100;
  ellipse(470, 200, leafDiameter, leafDiameter);
  ellipse(540, 140, leafDiameter, leafDiameter);
  ellipse(650, 100, leafDiameter, leafDiameter);
  ellipse(680, 140, leafDiameter, leafDiameter);
  ellipse(630, 120, leafDiameter, leafDiameter);
  ellipse(520, 130, leafDiameter + 20, leafDiameter + 20);
  ellipse(600, 80, leafDiameter + 20, leafDiameter + 20);
}

void drawBoat() {
  float r = BoatR;
  noStroke();
  fill(BoatColor);
  ellipse(BoatCenterX, BoatCenterY, r * 2, r * 2);
  fill(OceanColor);
  rect(BoatCenterX - r, BoatCenterY - 2 * r, r * 2, r * 2);
  fill(BoatColor);
  ellipse(BoatCenterX, BoatCenterY - r, r * 1.2, r * 1.2);
  fill(OceanColor);
  rect(BoatCenterX - r, BoatCenterY - 2 * r, r, r * 2);
  strokeWeight(2);
  stroke(BoatColor);
  line(BoatCenterX, BoatCenterY, BoatCenterX, BoatCenterY - r - r * 0.6);
  strokeWeight(1);
  stroke(BoatColor, 150);
  // draw the trail
  line(BoatCenterX - BoatTrailPos, BoatCenterY + r, BoatCenterX - BoatTrailPos - 10, BoatCenterY + r);
}

void drawAllStars() {
  if (TimeOfDay != NIGHT) {
    return;
  }
  
  noFill();
  stroke(StarColor);
  strokeWeight(2);
  drawAFewStars(708, 288); drawAFewStars(325, 75); drawAFewStars(251, 367);
  drawAFewStars(649,  96); drawAFewStars(301, 51); drawAFewStars(702, 265);
  drawAFewStars(353, 309); drawAFewStars(346, 70); drawAFewStars(220, 280);
}

void drawAFewStars(int x, int y) {
  drawPoint(x +  242, y + -233); drawPoint(x +  69, y +  -6); drawPoint(x +  -19, y + 111);
  drawPoint(x + -301, y +  203); drawPoint(x +  30, y + -57); drawPoint(x + -351, y + -21);
  drawPoint(x + -335, y + -138); drawPoint(x + 200, y +  14); drawPoint(x + -107, y +  89);
}

void drawPoint(int x, int y) {  
  line(mod(x + width, width), mod(y + height, 325), mod(x + width, width), mod(y + height, 325));
}