/*
In this scene, an image of sky and clouds is shown.
Then a poem will scroll up in the left.
The poem seems to be about someone's love for his/her lost dearest person.
When the poem ends, the pixels will move somewhat randomly down and to the right.
This creates a flowing water effect.
Then random pixels will turn into that of the next scene's first frame, until all of them do.
*/

PImage CloudImg;
PImage CloudImg2;
PImage FlowerImg;

PFont CloudFont;

boolean CloudSceneInit = false;

float HeavenTextY = 830;
float HeavenTextYSpeed = -1;

/* This is the poem that will scroll up. */
String HeavenText =
  "If I could\n        visit heaven,\n\n\n\n" +
  "Even for a day,\n\n\n\n" +
  "Maybe for a moment,\n\n\n\n" +
  "The pain would\n        go away,\n\n\n\n" +
  "I'd put my arms\n        around you,\n\n\n\n" +
  "And whisper words\n        so true,\n\n\n\n" +
  "That living life\n        without you,\n\n\n\n" +
  "Is the hardest thing\n        to do.\n\n\n\n" +
  "No matter how\n    I spend my days,\n\n\n\n" +
  "No matter what\n        I do,\n\n\n\n" +
  "No morning dawns\n    or evening falls,\n\n\n\n" +
  "When I don't\n        think of you\n\n\n\n";

/* The probability that a cloud pixel becomes a flower pixel.
This will be increased as time goes. */
float FlowerPixProb = 0.001;
  
void drawCloudScene() {
  if (!CloudSceneInit) {
    initCloudScene();
    CloudSceneInit = true;
  }
  
  if (t < 2.5) {
    /* display the scrolling poem */
    fill(255,254,253,255);    
    textFont(CloudFont);
    textSize(30);
    text(HeavenText, 70, HeavenTextY);
    HeavenTextY += HeavenTextYSpeed;
    loadPixels();
    for (int i = 0; i < height; ++i) {
      for (int j = 0; j < width; ++j) {      
        int pix = i * width + j;
        if (red(pixels[pix]) == 255 && green(pixels[pix]) == 254 && blue(pixels[pix]) == 253) {
          pixels[pix] = lerpColor(CloudImg.pixels[pix], CloudImg2.pixels[pix], 0);
        } else {
          // the background itself is a blend of two images
          pixels[pix] = lerpColor(CloudImg.pixels[pix], CloudImg2.pixels[pix], 0.5);
        }
      }
    }
    updatePixels();
    t += 0.001;
  } else {
    /* transit to the flower scene */
    loadPixels();
    for (int i = 0; i < height; ++i) {
      for (int j = 0; j < width; ++j) {
        int pix = i * width + j;
        int ii = i + int(random(0, 3));
        int jj = j + int(random(0, 3));
        if (ii >= height) ii = 0;
        if (jj >= width) jj = 0;
        int pixx = ii * width + jj;
        if (t > 5 && random(0, 1) < FlowerPixProb) {          
          pixels[pixx] = FlowerImg.pixels[ii * width + jj];
          FlowerPixProb += 0.0000001;
        } else {
          pixels[pixx] = pixels[pix];
        }
      }
    }
    updatePixels();
    t += 0.002;
    if (FlowerPixProb > 1) {
      /* end of this scene */
      T = 2;
      t = 0;            
    }
  }
}

void initCloudScene() {  
  t = 0;
}
