/*
This program consists of 3 consecutive "scenes".
Each scene is a static image with text that appears and disappears in some motion.
There are also transition motions between the scenes.
All the images used in this program are photos taken by me or given to me by a friend.
All the fonts used are freely available on the web. They are:
  - Cloud Home by Xerographer Fonts (www.dafont.com/cloudhome.font)
  - Lasting Love by Jonathan S. Harris (www.dafont.com/lasting-love.font)
  - McKloud Black by Jessica Slater (www.fontstock.net/270/mckloud-black.html)
  - Night Train 382 by Frederic Ric (www.dafont.com/night-train-382.font)  
*/

/* This is our global "time". It starts at 0 and increases from there.
The idea is that when T reaches 1, the second scene starts. When it reaches 2,
the third scene starts, and so on.
There's no way to speed up or slown down the animation,
but we can make T starts at 1 to begin from the second scene and so on. */
float T = 0.0;
/* Each scenes also has its "local time" that it can use to synchronize the different motions in the scene. */
float t = 0;

void setup() {
  smooth();
  size(1280, 800);

  /* train scene */
  TrainTextFont = loadFont("NightTrain382-60.vlw");
  ChimneyTextFont = loadFont("CloudHome-60.vlw");
  TrainImg = loadImage("train.png");
  CloudMixImg = loadImage("cloudmix.png");
  for (int i = 0; i < ChimneyText.length(); ++i) {
    ChimneyTextDx[i] = 1;
    ChimneyTextDy[i] = 0;
    ChimneyTextS[i] = 0;
    ChimneyTextX[i] = 1100;
    ChimneyTextY[i] = 300;
    ChimneyTextSign[i] = -1;
  }
  
  /* cloud scene */
  CloudImg = loadImage("cloud.png");
  CloudImg2 = loadImage("cloud2.png");
  FlowerImg = loadImage("flower7.png");
  CloudFont = loadFont("McKloudBlack-60.vlw");
  textFont(CloudFont);
  
  /* flower scene */
  for (int i = 0; i < FlowerImgs.length; ++i) {
    FlowerImgs[i] = loadImage("flower" + i + ".png");
  }
  FlowerFont = loadFont("LastingLove-48.vlw");
}

void draw() {
  if (T >= 0 && T < 1) {
    drawTrainScene();    
  } else if (T >= 1 && T < 2) {
    drawCloudScene();
  } else if (T >= 2) {
    drawFlowerScene();
  }  
}
